
; macroinstructions for defining and calling HLL procedures

macro stdcall proc,[arg]		; directly call STDCALL procedure
 { reverse
    pushd arg
   common
    call proc }

macro invoke proc,[arg] 		; indirectly call STDCALL procedure
 { common
    if ~ arg eq
   reverse
     pushd arg
   common
     call [proc]
    else
     call [proc]
    end if }

macro ccall proc,[arg]			; directly call CDECL procedure
 { common local size
    size = 0
   reverse
    pushd arg
    size = size+4
   common
    call proc
    add esp,size }

macro cinvoke proc,[arg]		; indirectly call CDECL procedure
 { common local size
    if ~ arg eq
     size = 0
   reverse
     pushd arg
     size = size+4
   common
     call [proc]
     add esp,size
    else
     call [proc]
    end if }

macro proc [params]			; define STDCALL procedure
 { common
    match name arg, params
    \{ if used name
       name:
       match =,args, arg \\{ defargs@proc args \\}
       match =all@args, all@args \{ defargs@proc arg \\} \}
    match =all@args, all@args
    \{ if used params
       params:
       ret@proc = 0
       all@args equ \}
    local current,size
    all@vars equ
    current = 0
    if ret@proc | size
     push ebp
     mov ebp,esp
     if size
      sub esp,size
     end if
    end if
    macro locals
    \{ virtual at ebp-size+current
       macro label . \\{ deflocal@proc .,: \\}
       struc db val \\{ deflocal@proc .,db val \\}
       struc dw val \\{ deflocal@proc .,dw val \\}
       struc dp val \\{ deflocal@proc .,dp val \\}
       struc dd val \\{ deflocal@proc .,dd val \\}
       struc dt val \\{ deflocal@proc .,dt val \\}
       struc dq val \\{ deflocal@proc .,dq val \\} \}
    macro endl
    \{ purge label
       restruc db,dw,dp,dd,dt,dq
       restruc byte,word,dword,pword,tword,qword
       current = $-(ebp-size)
       end virtual \}
    macro local [var]
    \{ \common locals
       \forward match varname:vartype,var \\{ varname vartype \\}
       \common endl \}
    macro finish@proc \{ size = (((current-1) shr 2)+1) shl 2 \}
    macro ret
    \{ if ret@proc | size
	 leave
       end if
       if ret@proc
	retn ret@proc
       else
	retn
       end if \} }

macro cproc [params]			 ; define CDECL procedure
 { common
    proc params
    ret@proc = 0 }

macro defargs@proc [arg]
 { common
    virtual at ebp+8
    if ~ arg eq
   forward
     local ..arg,current@arg
     match argname:type, arg
      \{ current@arg equ argname
	 label ..arg type
	 argname equ ..arg
	 if qword eq type | pword eq type
	   dq
	 else
	   dd ?
	 end if \}
     match =current@arg,current@arg
      \{ current@arg equ arg
	 arg equ ..arg
	 ..arg dd ? \}
   common
     all@args equ current@arg
   forward
     restore current@arg
   common
    end if
    ret@proc = $ - (ebp+8)
    end virtual }

macro deflocal@proc name,def
 { match any, all@vars \{ all@vars equ all@vars,name \}
   match ,all@vars \{ all@vars equ name \}
   local ..var
   name equ ..var
   ..var def }

macro endp
 { purge ret,locals,endl,local
   finish@proc
   purge finish@proc
   match all,all@args \{ restore all \}
   restore all@args
   match all,all@vars \{ restore all \}
   end if }
